.include "macros_h.s"
.include "bars.h"

.import CopyColorRam
.import FirstSlide
.import ShowSlideNext

.import __EFINITLO_RUN__, __EFINITHI_RUN__, __EFRUNLO_RUN__, __EFRUNHI_RUN__, __EFDELAY_RUN__, __EFDELAY_SIZE__

NumEffects=__EFDELAY_SIZE__

.segment "ZEROPAGE"
DemoState:
.byte 0
;Whether or not the "previous frame" is still running. If it is, only continue music,
EffectRunning:
.byte 0
CurrentEffectId:
.byte 0
EffectTimer:
.byte 0


.segment "EARLYCODE"
	.word $0801 ; Load address
	.word $080b
	.word 1
	.byte $9e,"2061",0,0,0
	;2601
	sei
	jsr $E544 ; Clear screen
	
	lda %00001011
	sta $D011 ; Screen OFF.
	lda #0
	tax
	jsr $0900 ; Init music
	lda #%01111111
	sta $dc0d  ;disable timer interrupts which can be generated by the two CIA chips
	sta $dd0d
	lda $dc0d
	sta $dd0d
	lda #%00110101 ; Set memory config. RAM everywhere, except for IO.
	sta $01

	lda #%00001011 ; Raster interrupt line bit 8 & defaults for others.
	sta $D011
	lda #255       ; Raster interrupt line bits 0-7.
	sta $D012
	lda #%00000001 ; Enable raster interrupts.
	sta $D01A
	SetPointer $FFFE, IRQ

	SetPointer BarHeight, BarHeight1
	SetPointer BarSpeed, BarSpeed1
	SetPointer BarTarget, BarTarget1

	jsr InitBarColors
	jsr InitBars
	jsr FirstSlide
	jsr InitBarsFirst
	lda #$FF
	sta CurrentEffectId
	lda #1
	sta EffectTimer
	lda #0
	sta EffectRunning
	sta $D021
	cli
	
busyloop:
	jmp busyloop

.proc IRQ
	pha
	txa
	pha
	tya
	pha
	asl $D019 ; Acknowledge interrupt.
	jsr $0903 ; Play one frame worth of music.
	ldy EffectRunning
	bne end
	iny
	sty EffectRunning
	cli ; Interrupts can happen now again, and music should play every frame.
	
	dec EffectTimer
	bne noefchange
	ldx CurrentEffectId
	inx
	stx CurrentEffectId
	cpx #.lobyte(NumEffects)
	bne noend
	;NOTE: We don't decrement EffectRunning, so the demo will display whatever was on the screen, and continuing to play music forever.
	pla
	tay
	pla
	tax
	pla
	rti

noend:
	lda __EFDELAY_RUN__, x
	sta EffectTimer
	lda __EFRUNLO_RUN__, x
	sta smcrun+1
	lda __EFRUNHI_RUN__, x
	sta smcrun+2
	lda __EFINITLO_RUN__, x
	sta smcinit+1
	lda __EFINITHI_RUN__, x
	sta smcinit+2
smcinit:
	jsr $C0DE
noefchange:
	
smcrun:
	jsr $C0DE

	sei
	dec EffectRunning
end:
	pla
	tay
	pla
	tax
	pla
	rti
.endproc

.rodata
BarHeight1:
.repeat 16, i
.byte i+2
.endrepeat

BarSpeed1:
.repeat 16
.byte 1
.endrepeat

BarTarget1:
.repeat 16, i
.byte i+10
.endrepeat
